var UserInfoController = function(ScreenService, MessageService, UserInfoService, PadraoExibicao, templateManager, ZhUtil, General) {
  /* global Constants */	
	let interval = null;
	let imgBkp = null;
    
	var retornaTipoInscJurid = function(tpInscJurid) {

		switch(tpInscJurid){

			case "J":
				return "Jurídica";
			case "I":
				return "";
			case "F":
				return "Física";
			case "O":
				return "Outros";
			default:
				return null;

		}

	};

	this.loadUserInfo = function(formWidget){

		UserInfoService.retornarUserInfo().then(function(callback){

			var userInfo = callback.dataset.userInfo[0];
			
			var nrinsjurforn = PadraoExibicao.mascaraFornecedor(userInfo.IDTPIJURFORN, userInfo.NRINSJURFORN);

			userInfo.IDTPIJURFORN = retornaTipoInscJurid(userInfo.IDTPIJURFORN);
			userInfo.NRINSJURFORN = nrinsjurforn;
			formWidget.currentRow = userInfo;
			formWidget.currentRow.FOTOLOGO = formWidget.currentRow.FOTOLOGO != null ? formWidget.currentRow.FOTOLOGO : window.undefinedImage;
			formWidget.activate();

		});

	};
	
	this.cancelEdit = function(widget) {
		const widPerfil = templateManager.container.getWidget('meuPerfil');
	    widget.currentRow.FOTOLOGO = imgBkp;
		delete widget.currentRow.IMAGE_UPLOAD;
	   	ScreenService.closePopup();
	    widPerfil.activate();
	};
	
	this.logoFornecedor = function() {
		const widUpload = templateManager.container.getWidget('widLogomarca');
		const widPerfil = templateManager.container.getWidget('meuPerfil');
		ScreenService.openPopup(widUpload);
		widUpload.currentRow.FOTOLOGO = widPerfil.currentRow.FOTOLOGO != null ? widPerfil.currentRow.FOTOLOGO : window.undefinedImage;
		imgBkp = widUpload.currentRow.FOTOLOGO;
		if (widUpload.currentRow.FOTOLOGO && widUpload.currentRow.FOTOLOGO != window.undefinedImage) {
			widUpload.getField('REMOVE_IMAGE').isVisible = true;
		} else {
			widUpload.getField('REMOVE_IMAGE').isVisible = false;
		}
		General.edit(widUpload);

	};
	
	this.onUploadPhoto = function (widget) {
		if (!interval) {
			let b64Bkp = Util.getNestedProperty(widget, ["currentRow", "IMAGE_UPLOAD", "0", "b64File"]);
			interval = setInterval(function () {
				var b64 = Util.getNestedProperty(widget, ["currentRow", "IMAGE_UPLOAD", "0", "b64File"]);
				var imageUpload = widget.currentRow.IMAGE_UPLOAD;
				if (!Util.isEmptyOrBlank(imageUpload) && b64Bkp != b64) {
					var validExt = widget.getField('IMAGE_UPLOAD').validations.extensions.value;
					var fileExt = '.' + imageUpload[0].name.split(".").pop();
					if (validExt.indexOf(fileExt) != -1) {
						widget.currentRow.FOTOLOGO = imageUpload[0].b64File;
						widget.getField('REMOVE_IMAGE').isVisible = true;
					} else {
						widget.currentRow.IMAGE_UPLOAD.splice(widget.currentRow.IMAGE_UPLOAD.indexOf(imageUpload), 1);
						widget.getField('IMAGE_UPLOAD').fileList = widget.currentRow.IMAGE_UPLOAD;
						widget.currentRow.FOTOLOGO = window.undefinedImage;
					}
					templateManager.updateTemplate();
					clearInterval(interval);
					interval = null;
				}
			}, 500);
		}
	};
	
	this.saveLogo = function (widget) {
		if(widget.isValid()){
			let currentRow = widget.currentRow;
			let widgetPerfil = widget.container.getWidget('meuPerfil');
			let fotoLogo = widget.currentRow.FOTOLOGO;
			if (fotoLogo === undefined || fotoLogo.length === 0 || fotoLogo === window.undefinedImage) {
				widget.currentRow.FOTOLOGO = null;
			}
			currentRow.CDFORNECED = getLocalVar('CDFORNECED');
			currentRow.DSFOTOFORNFILESERV = widgetPerfil.currentRow.DSFOTOFORNFILESERV;
			currentRow.FOTOLOGO = currentRow.FOTOLOGO != window.undefinedImage ? currentRow.FOTOLOGO : null;
			UserInfoService.saveLogoSupplier(widget.currentRow).then(function (success) {
				delete widget.currentRow.IMAGE_UPLOAD;
				widgetPerfil.reload().then(function(){
					let data = success.dataset.data;
					currentRow.FOTOLOGO = data.PATHIMAGE != null ? data.PATHIMAGE : window.undefinedImage;
	    	    	ScreenService.closePopup();
	    	    	MessageService.notificationMessageByCode("successOnSave", null, Constants.successNotification);
	    			widgetPerfil.currentRow.FOTOLOGO = currentRow.FOTOLOGO;
					widgetPerfil.activate();
				});
	    	    
			});
		}
	};
	
	this.removeImg = function (widget) {
		var remove = function () {
			widget.currentRow.FOTOLOGO = window.undefinedImage;
			widget.currentRow.IMAGE_UPLOAD = null;
			widget.getField('REMOVE_IMAGE').isVisible = false;
			templateManager.updateTemplate();
		};
		let config = {
            type: "question",
            icon: "question",
            actions: [
    			{
    				label: ScreenService.i18n('Sim'),
    				code: remove
    			},
    			{
    				label: ScreenService.i18n('Não')
    			}
    		]
        };
		MessageService.showCustomDialogByCode('confirmDeleteImage', null, config);
	};

};

Configuration(function(ContextRegister) {
	ContextRegister.register('UserInfoController', UserInfoController);
});
